#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

const long MAX_PLANETS = 50;
const double PI = 3.1415926535897932384;

double times[MAX_PLANETS];
double radii[MAX_PLANETS];
double x, y, angle;

int main(void)
{
#ifndef ONLINE_JUDGE
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	long cPlanets, iPlanet;
	double time;

	while (scanf("%ld %lf", &cPlanets, &time) == 2)
	{
		x = 0.0;
		y = 0.0;
		for (iPlanet = 0; iPlanet < cPlanets; ++iPlanet)
		{
			scanf("%lf %lf", &radii[iPlanet], &times[iPlanet]);

			angle = time * 2*PI / times[iPlanet];

			x = x + radii[iPlanet]*cos(angle);
			y = y + radii[iPlanet]*sin(angle);

			if (iPlanet > 0) putchar(' ');

			printf("%.4lf", sqrt(x*x + y*y));
		}
        putchar('\n');
	}


#ifndef ONLINE_JUDGE
	fclose(stdout);
	fclose(stdin);
#endif

	return 0;
}